﻿Imports System.Data.OleDb
Public Class Form1
    Dim con As OleDbConnection
    Dim da As OleDbDataAdapter
    Dim cmd As OleDbCommand
    Dim ds As DataSet
    Dim reg As Integer = 0
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        con = New OleDbConnection("Provider=Microsoft.Jet.Oledb.4.0;data source=C:\dados\Clientes.xls;Extended Properties=""Excel 8.0;HDR=Yes;"" ")
        'xldb.xls ->MS.Excel-2003 file, hdr=yes-> 1st row is treated as header
        carregadados()
        exibeDados()
    End Sub
    Private Sub carregadados()
        da = New OleDbDataAdapter("select * from [Clientes$]", con)
        'student-> sheet name in xldb.xls file, which should be specified as [student$]
        ds = New DataSet()
        da.Fill(ds, "Clientes")
        ds.Tables(0).Constraints.Add("pk_id", ds.Tables(0).Columns(0), True)
        'creating primary key in Tables["student"] of dataset(for using Find() method)
        gdvClientes.DataSource = ds.Tables(0)
    End Sub
    Private Sub exibeDados()
        txtCodigo.Text = ds.Tables(0).Rows(reg)(0).ToString()
        txtNome.Text = ds.Tables(0).Rows(reg)(1).ToString()
        txtEmail.Text = ds.Tables(0).Rows(reg)(2).ToString()
    End Sub

    Private Sub btnIncluir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnIncluir.Click
        cmd = New OleDbCommand((("insert into [Clientes$] values(" + txtCodigo.Text & ",' ") + txtNome.Text & " ',' ") + txtEmail.Text & " ') ", con)
        con.Open()
        Dim n As Integer = cmd.ExecuteNonQuery()
        con.Close()
        If n > 0 Then
            MessageBox.Show("Registro inserido com sucesso")
            carregadados()
        Else
            MessageBox.Show("Inclusão de registro falhou")
        End If
    End Sub

    Private Sub btnAlterar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAlterar.Click
        cmd = New OleDbCommand(((" update [Clientes$] set nome='" + txtNome.Text & "',email='") + txtEmail.Text & "' where id=") + txtCodigo.Text & " ", con)
        con.Open()
        Dim n As Integer = cmd.ExecuteNonQuery()
        con.Close()
        If n > 0 Then
            MessageBox.Show("Registro atualizado com sucesso.")
            carregadados()
        Else
            MessageBox.Show("Atualização de registro falhou.")
        End If
    End Sub

    Private Sub btnProcurar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProcurar.Click
        Try
            Dim n As Integer = Convert.ToInt32(InputBox("Informe o código do Cliente:", "Procurar", "2", 400, 400))
            Dim drow As DataRow = ds.Tables(0).Rows.Find(n)
            If drow IsNot Nothing Then
                txtCodigo.Text = drow(0).ToString()
                txtNome.Text = drow(1).ToString()
                txtEmail.Text = drow(2).ToString()
            Else
                MessageBox.Show("Registro não encontrado na planilha")
            End If
        Catch ex As Exception
        End Try
    End Sub

    Private Sub btnPrimeiro_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrimeiro.Click
        If ds.Tables(0).Rows.Count > 0 Then
            reg = 0
            exibeDados()
            MessageBox.Show("Primeiro Registro")
        Else
            MessageBox.Show("Não há registros")
        End If
    End Sub

    Private Sub btnAnterior_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAnterior.Click
        If ds.Tables(0).Rows.Count > 0 Then
            If reg > 0 Then
                reg -= 1
                exibeDados()
            Else
                MessageBox.Show("Primeiro Registro")
            End If
        Else
            MessageBox.Show("Não há registros")
        End If
    End Sub

    Private Sub btnProximo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnProximo.Click
        If ds.Tables(0).Rows.Count > 0 Then
            If reg < ds.Tables(0).Rows.Count - 1 Then
                reg += 1
                exibeDados()
            Else
                MessageBox.Show("Último Registro")
            End If
        Else
            MessageBox.Show("Não há registros")
        End If
    End Sub

    Private Sub btnUltimo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnUltimo.Click
        If ds.Tables(0).Rows.Count > 0 Then
            reg = ds.Tables(0).Rows.Count - 1
            exibeDados()
            MessageBox.Show("Último registro")
        Else
            MessageBox.Show("Não há registros")
        End If
    End Sub

    Private Sub btnLimpar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLimpar.Click
        txtCodigo.Text = ""
        txtNome.Text = ""
        txtEmail.Text = ""
    End Sub
End Class
